#include "..\\include\Lib_Clara.h"
#include "..\\include\Dir.h"
#include "..\\include\var_arg.h"
#include "registry.h"

char name_bk[] = "RegistryExample";

void elf_exit(void)
{
  kill_data(&ELF_BEGIN, (void(*)(void *))mfree_adr());
}

static void onMyBookClose(BOOK *book)
{
  SUBPROC(elf_exit);
}

int onExit(void *, BOOK *book)
{
  //  ,     ...        -
  //RegistryCache_SendSave(book);
  FreeBook(book);
  return(1);
}

static int MainPageOnCreate(void *, BOOK *book)
{
  // 
  
  int err;
  char _char = 15;
  u16 _u16 = 0xE5DF;
  int _int = 0x44FD67C9;
  char *str = "sony ericsson";
  wchar_t *wstr = L" ";
  
  
  //    
  err = RegistryBlock_GetNumberOfParameters(book);
  MessageBox(EMPTY_STRID,int2strID(err),0,1,20000,0);
  
  
  // char
  //    0
  //  - 
  //    - 
  //     -    
  if((err=(int)Registry_GetParameter(book, 0))<=2)
    Registry_AddParameter(book, &_char, sizeof(_char), 0);
  else
  {
    char *k = (char *)err;
    if(*k!=_char)
      Registry_AddParameter(book, &_char, sizeof(_char), 0);
    //  _char
    MessageBox(EMPTY_STRID,int2strID(*k),0,1,20000,0);
    mfree(k); //...
  }
  
  //  ............
  
  // u16
  if((err=(int)Registry_GetParameter(book, 1))<=2)
    Registry_AddParameter(book, &_u16, sizeof(_u16), 1);
  else
  {
    u16 *k = (u16 *)err;
    if(*k!=_u16)
      Registry_AddParameter(book, &_u16, sizeof(_u16), 1);
    
    MessageBox(EMPTY_STRID,int2strID(*k),0,1,20000,0);
    mfree(k);
  }
  
  // int
  if((err=(int)Registry_GetParameter(book, 2))<=2)
    Registry_AddParameter(book, &_int, sizeof(_int), 2);
  else
  {
    int *k = (int *)err;
    if(*k!=_int)
      Registry_AddParameter(book, &_int, sizeof(_int), 2);
    
    MessageBox(EMPTY_STRID,int2strID(*k),0,1,20000,0);
    mfree(k);
  }
  
  // char
  if((err=(int)Registry_GetParameter(book, 3))<=2)
    Registry_AddParameter(book, str, strlen(str)+1, 3);
  else
  {
    char *text = (char *)err;
    if(strcmp(text,str))
      Registry_AddParameter(book, str, strlen(str)+1, 3);
    
    MessageBox(EMPTY_STRID,Str2ID(text,1,strlen(text)),0,1,20000,0);
    mfree(text);
  }
  
  // wchar_t
  if((err=(int)Registry_GetParameter(book, 4))<=2)
    Registry_AddParameter(book, wstr, (wstrlen(wstr)+1)*2, 4);
  else
  {
    wchar_t *text = (wchar_t *)err;
    if(wstrcmp(text,wstr))
      Registry_AddParameter(book, wstr, (wstrlen(wstr)+1)*2, 4);
    
    MessageBox(EMPTY_STRID,Str2ID(text,0,wstrlen(text)),0,1,20000,0);
    mfree(text);
  }
  
  return(1);
}

const PAGE_MSG bk_msglst_main[] @ "DYN_PAGE"  = 
{
  PAGE_ENTER_EVENT_TAG,    MainPageOnCreate,
  NIL_EVENT_TAG,           NULL
};

const PAGE_DESC bk_main = {"RegistryExample_Main_Page",0,bk_msglst_main};

// -     =)
int GetCache(void *mes, BOOK *book)
{
  REGISTRY_CACHE *new_reg_c = (REGISTRY_CACHE *)mes;
  if((new_reg_c->BookID != book->BookID) && new_reg_c->cache)
  {
    if(get_cache()!=new_reg_c->cache)
    {
      set_cache(new_reg_c->cache);
      BookObj_GotoPage(book,&bk_main);
    }
  }
  return(1);
}

const PAGE_MSG bk_msglst_base[] @ "DYN_PAGE"  = 
{
  REGISTRY_CACHE_EVENT      ,GetCache,
  ELF_TERMINATE_EVENT       ,onExit,
  NIL_EVENT_TAG             ,NULL
};

const PAGE_DESC bk_base = {"RegistryExample_Base_Page",0,bk_msglst_base};

BOOK *NewBook(char *name_book)
{
  BOOK *book=new BOOK;
  memset(book,0,sizeof(BOOK));
  if(!CreateBook(book,onMyBookClose,&bk_base,name_book,-1,0))
  {
    delete book;
    SUBPROC(elf_exit);
    return(0);
  }
  return book;
}

int main()
{
  BOOK *book = NewBook(name_bk);
  RegistryCache_SendRequest(book);
  return(0);
}
