#include "..\\include\Lib_Clara.h"
#include "..\\include\Dir.h"
#include "registry.h"

LIST *RegistryList = 0;
u16 timer = 0; // ID 

void RegistryCache_SendRequest(BOOK *book)
{
  //debug_printf("\n---- (RegistryCache_SendRequest) ENTER ----\n");
  REGISTRY_CACHE *reg_c = new REGISTRY_CACHE;
  reg_c->cache = 0;
  reg_c->save = 0;
  reg_c->BookID = book->BookID;
  //debug_printf("\n(RegistryCache_SendRequest) Send GET_REGISTRY_CACHE_EVENT\n");
  //debug_printf("\n(RegistryCache_SendRequest) Message: Cache = 0x%X, BookID = 0x%X\n",reg_c->cache,reg_c->BookID);
  UI_Event_wData(REGISTRY_CACHE_EVENT,reg_c,(void (*)(void*))mfree_adr());
  //debug_printf("\n---- (RegistryCache_SendRequest) EXIT ----\n");
}

void RegistryCache_SendSave(BOOK *book)
{
  REGISTRY_CACHE *reg_c = new REGISTRY_CACHE;
  reg_c->cache = 0;
  reg_c->save = 1;
  reg_c->BookID = book->BookID;
  UI_Event_wData(REGISTRY_CACHE_EVENT,reg_c,(void (*)(void*))mfree_adr());
}

void onTimer(u16 timerID, LPARAM lparam)
{
  BOOK *book = (BOOK *)lparam;
  RegistryCache_SendSave(book);
  Timer_Kill(&timer);
}

/*
char *h2str(char *buf, int len)
{
  char *new_buf = new char[len*2+1+1];
  memset(new_buf,0,len*2+1);
  int i =0;
  char s;
  while(len--)
  {
    s=*buf++;
    char n = (s&0xF0)>>4;
    if((n>=0x0) && (n<=0x9)) n+=0x30;
    else if((n>=0xA) && (n<=0xF)) n+=0x37;
    new_buf[i++]=n;
    
    n = s&0xF;
    if((n>=0x0) && (n<=0x9)) n+=0x30;
    else if((n>=0xA) && (n<=0xF)) n+=0x37;
    new_buf[i++]=n;
  }
  return(new_buf);
}
*/


wchar_t *GetRegistryPath(void)
{
  wchar_t *dir = L"/Registry";
  wchar_t *path = new wchar_t[wstrlen(GetDir(DIR_ELFS|MEM_INTERNAL))+wstrlen(dir)+1];
  wstrcpy(path,GetDir(DIR_ELFS|MEM_INTERNAL));
  wstrcat(path,dir);
  //debug_printf("\n(GetRegistryPath) RegistryPath: %ls\n",path);
  return(path);
}

char *FindBlockInCache(char *name_book, LIST *lst)
{
  //debug_printf("\n(FindBlockInCache) RegistryList->FirstFree: %d\n",lst->FirstFree);
  //debug_printf("\n(FindBlockInCache) NameBook: %s\n",name_book);
  for(int i=0;i<(lst->FirstFree);i++) //  
  {
    char *block = (char *)ListElement_GetByIndex(lst,i);
    char *block_name_book = block+2;
    //debug_printf("\n(FindBlockInCache) FindNameBook: %s, i = %d\n",block_name_book,i);
    if(!strcmp(block_name_book,name_book)) return(block);
    //debug_printf("\n*******************\n");
  }
  //debug_printf("\n(FindBlockInCache) no block\n");
  return(0); //  (
}

int RemoveBlockFromCache(char *name_book, LIST *lst)
{
  for(int i=0;i<(lst->FirstFree);i++) //  
  {
    char *block = (char *)ListElement_GetByIndex(lst,i);
    char *block_name_book = block+2;
    if(!strcmp(block_name_book,name_book))
    {
      mfree(block);
      ListElement_Remove(RegistryList,i);
      return(1); // 
    }
  }
  return(0); //  (
}

void *Registry_GetParameter(BOOK *book, int num_var)
{
  //debug_printf("\n---- (Registry_GetParameter) ENTER ----\n");
  //debug_printf("\nPARAM: name_bk=%s, num_var=%d\n",name_bk,num_var);
  char *block;
  char *name_bk = book->xbook->name;
  int len_name_bk = strlen(name_bk);
  
  if(RegistryList->FirstFree) //    -?
  {
    //debug_printf("\n(Registry_GetParameter) RegistryList->FirstFree: %d\n",RegistryList->FirstFree);
    if(block=FindBlockInCache(name_bk,RegistryList))
    {
      int num_all_var = block[2+len_name_bk+1];
      if(num_all_var<=num_var) return((char *)2); //    
      else
      { //  
        block+=2+len_name_bk+1+1;
        for(int i=0;;i++)
        {
          block+=4;
          int len_var_in_block = (block[1]<<8)|block[0];
          block+=2;
          if(i==num_var)
          {
            void *m = malloc(len_var_in_block);
            memcpy(m,block,len_var_in_block);
            return(m); //   ,   ))
          }
          block+=len_var_in_block;
        }
      }
    }
    else 
    {
      //debug_printf("\n(Registry_GetParameter) no block\n");
      //debug_printf("\n(Registry_GetParameter) return ERROR: 0x1\n");
      return((char *)1); //  
    }
  }
  else 
  {
    //debug_printf("\n(Registry_GetParameter) FirstFree = 0x0!!!\n");
    //debug_printf("\n(Registry_GetParameter) return ERROR: 0x0\n");
    return((char *)0); // registry    )
  }
}

void Registry_AddParameter(BOOK *book, void *r, u16 len_var, int num_var)
{
  DATETIME dt;
  char *block;
  char *name_bk = book->xbook->name;
  int len_name_bk = strlen(name_bk);
  wchar_t *path = GetRegistryPath();
  int err = (int)Registry_GetParameter(book, num_var);
  
  if(err==0 || err==1)
  {
    int len_block = 2+len_name_bk+1+1+4+2+len_var;
    //2 -  
    //len_name_bk+1 -  
    //1 -    
    //4 - ,,,
    //2 -  
    //len_var - 
      
    block = new char[len_block];
    memset(block,0,len_block);
    block[0]=((len_block<<24)>>24);
    block[1]=((len_block<<16)>>24);
    strcpy(block+2,name_bk);
      
    block[2+len_name_bk+1]=1;
    REQUEST_DATEANDTIME_GET(SYNC, &dt);
    block[2+len_name_bk+1+1]=dt.time.hour;
    block[2+len_name_bk+1+2]=dt.date.day;
    block[2+len_name_bk+1+3]=dt.date.mon;
    block[2+len_name_bk+1+4]=((dt.date.year<<24)>>24);
    block[2+len_name_bk+1+5]=((len_var<<24)>>24);
    block[2+len_name_bk+1+6]=((len_var<<16)>>24);
    memcpy(block+2+len_name_bk+1+1+4+2,r,len_var);
      
    int f = _fopen(path,L"registry",0x004,0x180,0);
    lseek(f,0,2);
    fwrite(f,block,len_block);
    fclose(f);
      
    ListElement_Add(RegistryList,block);
    if(timer==0) timer = Timer_Set(70,onTimer,(LPARAM)book);
      
    mfree(path);
  }
  else if(err==2)
  {
    //        
    char *new_block;
    block=FindBlockInCache(name_bk,RegistryList);
    //debug_printf("\n(Registry_AddParameter) Old block: 0x%X\n",block);
    u16 len_block = (block[1]<<8)|block[0];
    u16 new_len_block = len_block+4+2+len_var;
    new_block = new char[new_len_block];
    memset(new_block,0,new_len_block);
    memcpy(new_block,block,len_block);
    new_block[2+len_name_bk+1]+=1;
          
    RemoveBlockFromCache(name_bk,RegistryList);
    //debug_printf("\n(Registry_AddParameter) Remove old block: 0x%X\n",block);
          
    new_block[0]=((new_len_block<<24)>>24);
    new_block[1]=((new_len_block<<16)>>24);
    REQUEST_DATEANDTIME_GET(SYNC, &dt);
    new_block[len_block]=dt.time.hour;
    new_block[len_block+1]=dt.date.day;
    new_block[len_block+2]=dt.date.mon;
    new_block[len_block+3]=((dt.date.year<<24)>>24);
    new_block[len_block+4]=((len_var<<24)>>24);
    new_block[len_block+5]=((len_var<<16)>>24);
    memcpy(new_block+len_block+4+2,r,len_var);
          
    ListElement_Add(RegistryList,new_block);
    //debug_printf("\n(Registry_AddParameter) Add new block: 0x%X\n",new_block);
          
    if(timer==0) timer = Timer_Set(70,onTimer,(LPARAM)book);
  }
  else
  {
    char *new_block;
    block=FindBlockInCache(name_bk,RegistryList);
    
    u16 len_all_block = (block[1]<<8)|block[0];
    u16 len_var_in_block;
    char *res_block = block;
    res_block+=2+len_name_bk+1+1;
    for(int k=0;k!=num_var;k++)
    {
      res_block+=4;
      len_var_in_block = (res_block[1]<<8)|res_block[0];
      res_block+=(2+len_var_in_block);
    }
    
    int old_len_var=(res_block[5]<<8)|res_block[4];
    res_block = block;
    res_block+=2+len_name_bk+1+1;
    
    if(len_var>old_len_var) len_all_block+=(len_var-old_len_var);
    else len_all_block-=(old_len_var-len_var);
          
    new_block = new char[len_all_block];
    memset(new_block,0,len_all_block);
    new_block[0]=((len_all_block<<24)>>24);
    new_block[1]=((len_all_block<<16)>>24);
    strcpy(new_block+2,name_bk);
    int all_var = new_block[2+len_name_bk+1]=block[2+len_name_bk+1];
    char *res_new_block = new_block;
    res_new_block+=2+len_name_bk+1+1;
    for(int k=0;k!=num_var;k++)
    {
      len_var_in_block = (res_block[5]<<8)|res_block[4];
      memcpy(res_new_block,res_block,4+2+len_var_in_block);
      res_new_block+=(4+2+len_var_in_block);
      res_block+=(4+2+len_var_in_block);
    }
    
    REQUEST_DATEANDTIME_GET(SYNC, &dt);
    res_new_block[0]=dt.time.hour;
    res_new_block[1]=dt.date.day;
    res_new_block[2]=dt.date.mon;
    res_new_block[3]=((dt.date.year<<24)>>24);
    res_new_block[4]=((len_var<<24)>>24);
    res_new_block[5]=((len_var<<16)>>24);
    memcpy(res_new_block+4+2,r,len_var);
    if(num_var<(all_var-1))
    {
      int raz = all_var-1-num_var;
      res_new_block+=(4+2+len_var);
      res_block+=(4+2+old_len_var);
      for(int k=0;k!=raz;k++)
      {
        len_var_in_block = (res_block[5]<<8)|res_block[4];
        memcpy(res_new_block,res_block,4+2+len_var_in_block);
        res_new_block+=(4+2+len_var_in_block);
        res_block+=(4+2+len_var_in_block);
      }
    }
    RemoveBlockFromCache(name_bk,RegistryList);
    ListElement_Add(RegistryList,new_block);
    
    if(timer==0) timer = Timer_Set(70,onTimer,(LPARAM)book);
  }
}

int RegistryBlock_GetNumberOfParameters(BOOK *book)
{
  char *block;
  char *name_bk = book->xbook->name;
  if(block=FindBlockInCache(name_bk,RegistryList))
  {
    int len_name_bk = strlen(name_bk);
    return(block[2+len_name_bk+1]);
  }
  else return(-1); //  
}

int Registry_RemoveLastParameter(BOOK *book)
{
  char *block;
  int len_var_in_block;
  char *name_bk = book->xbook->name;
  int len_name_bk = strlen(name_bk);
  if(block=FindBlockInCache(name_bk,RegistryList))
  {
    u16 len_all_block = (block[1]<<8)|block[0];
    int num_all_var = block[2+len_name_bk+1];
    if(num_all_var==1) RemoveBlockFromCache(name_bk,RegistryList);
    else
    {
      char *res_block = block;
      res_block+=2+len_name_bk+1+1;
      
      for(int i=0;i!=(num_all_var-1);i++)
      {
        res_block+=4;
        len_var_in_block = (res_block[1]<<8)|res_block[0];
        res_block+=(2+len_var_in_block);
      }
      
      res_block+=4;
      len_var_in_block = (res_block[1]<<8)|res_block[0];
      len_all_block-=4+2+len_var_in_block;
    
      char *new_block = new char[len_all_block];
      memcpy(new_block,block,len_all_block);
      new_block[0]=((len_all_block<<24)>>24);
      new_block[1]=((len_all_block<<16)>>24);
      new_block[2+len_name_bk+1]=block[2+len_name_bk+1]-1;
    
      RemoveBlockFromCache(name_bk,RegistryList);
      ListElement_Add(RegistryList,new_block);
      
      if(timer==0) timer = Timer_Set(70,onTimer,(LPARAM)book);
    }
  }
  else return(1); //  
  return(0);
}

int set_cache(LIST *lst)
{
  RegistryList = lst;
  return(0);
}

LIST *get_cache(void)
{
  return(RegistryList);
}
